{-# OPTIONS_GHC -fno-warn-unused-imports #-}
#include <bindings.dsl.h>
#include <bindings.cmacros.h>
#include <hamlib/riglist.h>

module Bindings.Hamlib.Riglist where
import Foreign.Ptr
#strict_import

{- typedef int rig_model_t; -}
#synonym_t rig_model_t , CInt

#cinline RIG_MAKE_MODEL , CInt -> CInt -> CInt
#cinline RIG_BACKEND_NUM , CInt -> CInt

-- grep define /usr/include/hamlib/riglist.h | sed 's/\/\*.*//g' | grep -v '"' | awk '{print $2}' | sed 's/^/#num /' | tail -n+5 | head -n-1
#num RIG_MODEL_NONE
#num RIG_DUMMY
#num RIG_MODEL_DUMMY
#num RIG_MODEL_NETRIGCTL
#num RIG_MODEL_ARMSTRONG
#num RIG_YAESU
#num RIG_MODEL_FT847
#num RIG_MODEL_FT1000
#num RIG_MODEL_FT1000D
#num RIG_MODEL_FT1000MPMKV
#num RIG_MODEL_FT747
#num RIG_MODEL_FT757
#num RIG_MODEL_FT757GXII
#num RIG_MODEL_FT575
#num RIG_MODEL_FT767
#num RIG_MODEL_FT736R
#num RIG_MODEL_FT840
#num RIG_MODEL_FT820
#num RIG_MODEL_FT900
#num RIG_MODEL_FT920
#num RIG_MODEL_FT890
#num RIG_MODEL_FT990
#num RIG_MODEL_FRG100
#num RIG_MODEL_FRG9600
#num RIG_MODEL_FRG8800
#num RIG_MODEL_FT817
#num RIG_MODEL_FT100
#num RIG_MODEL_FT857
#num RIG_MODEL_FT897
#num RIG_MODEL_FT1000MP
#num RIG_MODEL_FT1000MPMKVFLD
#num RIG_MODEL_VR5000
#num RIG_MODEL_FT450
#num RIG_MODEL_FT950
#num RIG_MODEL_FT2000
#num RIG_MODEL_FT9000
#num RIG_MODEL_FT980
#num RIG_MODEL_FTDX5000
#num RIG_MODEL_VX1700
#num RIG_KENWOOD
#num RIG_MODEL_TS50
#num RIG_MODEL_TS440
#num RIG_MODEL_TS450S
#num RIG_MODEL_TS570D
#num RIG_MODEL_TS690S
#num RIG_MODEL_TS711
#num RIG_MODEL_TS790
#num RIG_MODEL_TS811
#num RIG_MODEL_TS850
#num RIG_MODEL_TS870S
#num RIG_MODEL_TS940
#num RIG_MODEL_TS950
#num RIG_MODEL_TS950SDX
#num RIG_MODEL_TS2000
#num RIG_MODEL_R5000
#num RIG_MODEL_TS570S
#num RIG_MODEL_THD7A
#num RIG_MODEL_THD7AG
#num RIG_MODEL_THF6A
#num RIG_MODEL_THF7E
#num RIG_MODEL_K2
#num RIG_MODEL_TS930
#num RIG_MODEL_THG71
#num RIG_MODEL_TS680S
#num RIG_MODEL_TS140S
#num RIG_MODEL_TMD700
#num RIG_MODEL_TMV7
#num RIG_MODEL_TS480
#num RIG_MODEL_K3
#num RIG_MODEL_TRC80
#num RIG_MODEL_TS590S
#num RIG_MODEL_TRANSFOX
#num RIG_MODEL_THD72A
#num RIG_MODEL_TMD710
#num RIG_MODEL_TMV71
#num RIG_ICOM
#num RIG_MODEL_IC1271
#num RIG_MODEL_IC1275
#num RIG_MODEL_IC271
#num RIG_MODEL_IC275
#num RIG_MODEL_IC375
#num RIG_MODEL_IC471
#num RIG_MODEL_IC475
#num RIG_MODEL_IC575
#num RIG_MODEL_IC706
#num RIG_MODEL_IC706MKII
#num RIG_MODEL_IC706MKIIG
#num RIG_MODEL_IC707
#num RIG_MODEL_IC718
#num RIG_MODEL_IC725
#num RIG_MODEL_IC726
#num RIG_MODEL_IC728
#num RIG_MODEL_IC729
#num RIG_MODEL_IC731
#num RIG_MODEL_IC735
#num RIG_MODEL_IC736
#num RIG_MODEL_IC737
#num RIG_MODEL_IC738
#num RIG_MODEL_IC746
#num RIG_MODEL_IC751
#num RIG_MODEL_IC751A
#num RIG_MODEL_IC756
#num RIG_MODEL_IC756PRO
#num RIG_MODEL_IC761
#num RIG_MODEL_IC765
#num RIG_MODEL_IC775
#num RIG_MODEL_IC781
#num RIG_MODEL_IC820
#num RIG_MODEL_IC821
#num RIG_MODEL_IC821H
#num RIG_MODEL_IC970
#num RIG_MODEL_ICR10
#num RIG_MODEL_ICR71
#num RIG_MODEL_ICR72
#num RIG_MODEL_ICR75
#num RIG_MODEL_ICR7000
#num RIG_MODEL_ICR7100
#num RIG_MODEL_ICR8500
#num RIG_MODEL_ICR9000
#num RIG_MODEL_IC910
#num RIG_MODEL_IC78
#num RIG_MODEL_IC746PRO
#num RIG_MODEL_IC756PROII
#num RIG_MODEL_ICID1
#num RIG_MODEL_IC703
#num RIG_MODEL_IC7800
#num RIG_MODEL_IC756PROIII
#num RIG_MODEL_ICR20
#num RIG_MODEL_IC7000
#num RIG_MODEL_IC7200
#num RIG_MODEL_IC7700
#num RIG_MODEL_IC7600
#num RIG_MODEL_IC92D
#num RIG_MODEL_ICR9500
#num RIG_MODEL_IC7410
#num RIG_MODEL_IC9100
#num RIG_MODEL_ICRX7
#num RIG_MODEL_MINISCOUT
#num RIG_MODEL_XPLORER
#num RIG_MODEL_OS535
#num RIG_MODEL_OS456
#num RIG_MODEL_OMNIVI
#num RIG_MODEL_OMNIVIP
#num RIG_MODEL_PARAGON2
#num RIG_MODEL_DELTAII
#num RIG_PCR
#num RIG_MODEL_PCR1000
#num RIG_MODEL_PCR100
#num RIG_MODEL_PCR1500
#num RIG_MODEL_PCR2500
#num RIG_AOR
#num RIG_MODEL_AR8200
#num RIG_MODEL_AR8000
#num RIG_MODEL_AR7030
#num RIG_MODEL_AR5000
#num RIG_MODEL_AR3030
#num RIG_MODEL_AR3000A
#num RIG_MODEL_AR3000
#num RIG_MODEL_AR2700
#num RIG_MODEL_AR2500
#num RIG_MODEL_AR16
#num RIG_MODEL_SDU5500
#num RIG_MODEL_SDU5000
#num RIG_MODEL_AR8600
#num RIG_MODEL_AR5000A
#num RIG_MODEL_AR7030P
#num RIG_MODEL_SR2200
#num RIG_JRC
#num RIG_MODEL_JST145
#num RIG_MODEL_JST245
#num RIG_MODEL_CMH530
#num RIG_MODEL_NRD345
#num RIG_MODEL_NRD525
#num RIG_MODEL_NRD535
#num RIG_MODEL_NRD545
#num RIG_RADIOSHACK
#num RIG_MODEL_RS64
#num RIG_MODEL_RS2005
#num RIG_MODEL_RS2006
#num RIG_MODEL_RS2035
#num RIG_MODEL_RS2042
#num RIG_MODEL_RS2041
#num RIG_UNIDEN
#num RIG_MODEL_BC780
#num RIG_MODEL_BC245
#num RIG_MODEL_BC895
#num RIG_MODEL_PRO2052
#num RIG_MODEL_BC235
#num RIG_MODEL_BC250
#num RIG_MODEL_BC785
#num RIG_MODEL_BC786
#num RIG_MODEL_BCT8
#num RIG_MODEL_BCD396T
#num RIG_MODEL_BCD996T
#num RIG_MODEL_BC898
#num RIG_DRAKE
#num RIG_MODEL_DKR8
#num RIG_MODEL_DKR8A
#num RIG_MODEL_DKR8B
#num RIG_LOWE
#num RIG_MODEL_HF150
#num RIG_MODEL_HF225
#num RIG_MODEL_HF250
#num RIG_MODEL_HF235
#num RIG_RACAL
#num RIG_MODEL_RA3790
#num RIG_MODEL_RA3720
#num RIG_MODEL_RA6790
#num RIG_MODEL_RA3710
#num RIG_MODEL_RA3702
#num RIG_WJ
#num RIG_MODEL_HF1000
#num RIG_MODEL_HF1000A
#num RIG_MODEL_WJ8711
#num RIG_MODEL_WJ8888
#num RIG_EK
#num RIG_MODEL_ESM500
#num RIG_MODEL_EK890
#num RIG_MODEL_EK891
#num RIG_MODEL_EK895
#num RIG_MODEL_EK070
#num RIG_SKANTI
#num RIG_MODEL_TRP7000
#num RIG_MODEL_TRP8000
#num RIG_MODEL_TRP9000
#num RIG_MODEL_TRP8255
#num RIG_WINRADIO
#num RIG_MODEL_WR1000
#num RIG_MODEL_WR1500
#num RIG_MODEL_WR1550
#num RIG_MODEL_WR3100
#num RIG_MODEL_WR3150
#num RIG_MODEL_WR3500
#num RIG_MODEL_WR3700
#num RIG_MODEL_G303
#num RIG_MODEL_G313
#num RIG_MODEL_G305
#num RIG_MODEL_G315
#num RIG_TENTEC
#num RIG_MODEL_TT550
#num RIG_MODEL_TT538
#num RIG_MODEL_RX320
#num RIG_MODEL_RX340
#num RIG_MODEL_RX350
#num RIG_MODEL_TT526
#num RIG_MODEL_TT516
#num RIG_MODEL_TT565
#num RIG_MODEL_TT585
#num RIG_MODEL_TT588
#num RIG_MODEL_RX331
#num RIG_MODEL_TT599
#num RIG_ALINCO
#num RIG_MODEL_DX77
#num RIG_KACHINA
#num RIG_MODEL_505DSP
#num RIG_RPC
#num RIG_MODEL_RPC
#num RIG_GNURADIO
#num RIG_MODEL_GNURADIO
#num RIG_MODEL_MC4020
#num RIG_MODEL_GRAUDIO
#num RIG_MODEL_GRAUDIOIQ
#num RIG_MODEL_USRP_G
#num RIG_MICROTUNE
#num RIG_MODEL_MICROTUNE_4937
#num RIG_MODEL_MICROTUNE_4702
#num RIG_MODEL_MICROTUNE_4707
#num RIG_TAPR
#num RIG_MODEL_DSP10
#num RIG_FLEXRADIO
#num RIG_MODEL_SDR1000
#num RIG_MODEL_SDR1000RFE
#num RIG_MODEL_DTTSP
#num RIG_MODEL_DTTSP_UDP
#num RIG_RFT
#num RIG_MODEL_EKD500
#num RIG_KIT
#num RIG_MODEL_ELEKTOR304
#num RIG_MODEL_DRT1
#num RIG_MODEL_DWT
#num RIG_MODEL_USRP0
#num RIG_MODEL_USRP
#num RIG_MODEL_DDS60
#num RIG_MODEL_ELEKTOR507
#num RIG_MODEL_MINIVNA
#num RIG_MODEL_SI570AVRUSB
#num RIG_MODEL_PMSDR
#num RIG_MODEL_SI570PICUSB
#num RIG_MODEL_FIFISDR
#num RIG_MODEL_FUNCUBEDONGLE
#num RIG_MODEL_HIQSDR
#num RIG_TUNER
#num RIG_MODEL_V4L
#num RIG_MODEL_V4L2
#num RIG_RS
#num RIG_MODEL_ESMC
#num RIG_MODEL_EB200
#num RIG_PRM80
#num RIG_MODEL_PRM8060
#num RIG_MODEL_PRM8070
#num RIG_ADAT
#num RIG_MODEL_ADT_200A

-- grep define /usr/include/hamlib/riglist.h | sed 's/\/\*.*//g' | grep '"' | awk '{print $2}' | sed 's/^/#globalarray /' | sed 's/$/ , CString/'
#globalarray RIG_BACKEND_DUMMY , CChar
#globalarray RIG_BACKEND_YAESU , CChar
#globalarray RIG_BACKEND_KENWOOD , CChar
#globalarray RIG_BACKEND_ICOM , CChar
#globalarray RIG_BACKEND_PCR , CChar
#globalarray RIG_BACKEND_AOR , CChar
#globalarray RIG_BACKEND_JRC , CChar
#globalarray RIG_BACKEND_RADIOSHACK , CChar
#globalarray RIG_BACKEND_UNIDEN , CChar
#globalarray RIG_BACKEND_DRAKE , CChar
#globalarray RIG_BACKEND_LOWE , CChar
#globalarray RIG_BACKEND_RACAL , CChar
#globalarray RIG_BACKEND_WJ , CChar
#globalarray RIG_BACKEND_EK , CChar
#globalarray RIG_BACKEND_SKANTI , CChar
#globalarray RIG_BACKEND_WINRADIO , CChar
#globalarray RIG_BACKEND_TENTEC , CChar
#globalarray RIG_BACKEND_ALINCO , CChar
#globalarray RIG_BACKEND_KACHINA , CChar
#globalarray RIG_BACKEND_RPC , CChar
#globalarray RIG_BACKEND_GNURADIO , CChar
#globalarray RIG_BACKEND_MICROTUNE , CChar
#globalarray RIG_BACKEND_TAPR , CChar
#globalarray RIG_BACKEND_FLEXRADIO , CChar
#globalarray RIG_BACKEND_RFT , CChar
#globalarray RIG_BACKEND_KIT , CChar
#globalarray RIG_BACKEND_TUNER , CChar
#globalarray RIG_BACKEND_RS , CChar
#globalarray RIG_BACKEND_PRM80 , CChar
#globalarray RIG_BACKEND_ADAT , CChar
